<?php
include("argv.class.php");

/**
 * Yet another nice script by mr.The
 * Contact:
 * Icq: 11889888
 * Jabber: mr.the@jabber.org
 * Skype: mr-the
*/

if(count($argv)<=1) {
	echo "\nVkontakte Song Extractor\nBy mr.The\n\nUsage: php script.php -l login -p pass -l songlist\n
-l vk.com login
-p vk.com pass
-s song list(file)
-b minimal bitrate. Default: 128
-o outfile(with links). Default: ./out.txt
-t temp directory. Default: /tmp/

Example:
php script.php -l login@some.site -p coolpassword -l songs.txt -b 320 -o out.txt -t ./
\n";
	die;
}


$arg=new Args();


$arg->flag("l") ? $login=$arg->flag("l") : die("\nWhere is login?!\n");
$arg->flag("p") ? $pass=$arg->flag("p") : die("\nWhere is pass?!\n");
$arg->flag("s") ? $songFile=$arg->flag("s") : die("\nWhere is song file?!\n");

$arg->flag("b") ? $minBitRate=$arg->flag("b") : $minBitRate=128;
$arg->flag("o") ? $outfile=$arg->flag("o") : $outfile="./out.txt";
$arg->flag("t") ? $tempDir=$arg->flag("t") : $tempDir="/tmp/";

define("LOGIN", $login);
define("PASSWORD", $pass);

$songList=file($songFile);

echo "Starting..\n";

foreach($songList as $songName) {
	$songName=trim($songName);
	$songs=getSongsList($songName);
	
	if(!$songs) {
		echo "No songs like '$songName' found!\n";
		continue;
	}
	echo "Songs list loaded..\n";
		
	$i=0;
	foreach($songs[1] as $song) {
		$i++;
		
		$sname="$tempDir/song_".rand(0,9999999).".mp3";
		file_put_contents($sname, file_get_contents($song, NULL, NULL, 0, 3100) );
		$birRate=getBitrateByFile(trim($sname));
		unlink($sname);
		
		echo $songName." - ".$birRate;
		
		if($birRate>=$minBitRate) { 
			echo " - Nice file!\n";
			to_file($outfile, $song);
			break;
		}
		
		echo "\n";
	}
}


function to_file($file,$text) {
	$f=fopen($file,"a+");
	fwrite($f, $text."\n");
	fclose($f);
}

function getSongsList($q, $c=0) {
	$musicPage=getVkPage("http://vk.com/audio", "act=search&al=1&gid=0&id=&offset=0&q=$q&sort=2");

	if(!strstr($musicPage, "playAudioNew")) {
			if($c==1) {
				die("Can't login!\n");
			}
			echo "Login..\n";
			vkLogin(LOGIN, PASSWORD);
			getSongsList($q, 1);
	}

	//preg_match_all("|<input type=\"hidden\" id=\"audio_info[^\"]+\" value=\"([^\",]+),[^\"]+\" />.+<div class=\"title_wrap\">.+<span>([^<>]+)</span></a></b> - <span class=\"title\">([^<>]+)</span>|Uis", $musicPage, $rnd);
	
	preg_match_all("|<input type=\"hidden\" id=\"audio_info[^\"]+\" value=\"([^\",]+),[^\"]+\" />|Uis", $musicPage, $rnd);

	if(!isset($rnd[1]))
		return false;
		
	unset($rnd[0]);
	
	return $rnd;
}

//Login to VK
function vkLogin($login, $pass) {
	getVkPage("http://login.vk.com/?act=login", 
    "act=login&q=1&al_frame=1&expire=&captcha_sid=&captcha_key=&from_host=vk.com&email=$login&pass=$pass", "http://vk.com/");
}

/**
Get page with Curl
**/
function getVkPage($url,$post='',$ref='') {
    $ch = curl_init();
 
    curl_setopt($ch, CURLOPT_URL,$url);
    curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/535.1 (KHTML, like Gecko) Ubuntu/10.10 Chromium/13.0.782.215 Chrome/13.0.782.215 Safari/535.1");
    curl_setopt($ch, CURLOPT_REFERER,$ref);

 
    if($post!==''){
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    }
 
    $headers [] = "Accept: text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1";
    $headers [] = "Accept-Language: ru,en;q=0.9,ru-RU;q=0.8";
    $headers [] = "Connection: close";
    $headers [] = "Cache-Control: no-store, no-cache, must-revalidate";
 
    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
 
    curl_setopt($ch, CURLOPT_HEADER, 1);
    curl_setopt($ch, CURLOPT_FAILONERROR, 1);
    curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
    curl_setopt($ch, CURLOPT_COOKIEFILE, "./cookie.txt");
	curl_setopt($ch, CURLOPT_COOKIEJAR, "./cookie.txt");
    curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
    curl_setopt($ch, CURLOPT_TIMEOUT, 20);
    curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 20);
    $result = curl_exec($ch);
    curl_close($ch);
    if($result)return $result; else    return false;
}

//Get file Bitrate
function getBitrateByFile($file) {
	for($i=0;$i<3000;$i++) {
		$fp=fopen("$file", "r");
		fseek($fp, $i);
		$data=fread($fp, 2);

		if(bin2hex($data)=="fffb" or substr(bin2hex($data),0,3)=="fff") { //fffuuuuuuuuu
			return getBitrateByByte(bin2hex(fread($fp, 1)));
			break;
		}
		
		fclose($fp);
			//echo $file." - ".getBitrateByByte(bin2hex($data))."\n";
	}
}

//Bitrate array. 
function getBitrateByByte($byte) {
	$BitrateArray=array (
		'1' => 32,
		'2' => 40,
		'3' => 48,
		'4' => 56,
		'5' => 64,
		'6' => 80,
		'7' => 96,
		'8' => 112,
		'9' => 128,
		'a' => 160,
		'b' => 192,
		'c' => 224,
		'd' => 256,
		'e' => 320,
		'f' => 0
	);

	$byte=substr($byte, 0, 1);
	if(!isset($BitrateArray[$byte])) return 0;
	return $BitrateArray[$byte];
}
?>
